-- B84007B.ADA

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making
--     this public release, the Government intends to confer upon all
--     recipients unlimited rights  equal to those held by the Government.
--     These rights include rights to use, duplicate, release or disclose the
--     released technical data and computer software in whole or in part, in
--     any manner and for any purpose whatsoever, and to have or permit others
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- OBJECTIVE:
--     CHECK THAT LOGICAL OPERATORS ON MODULAR TYPES DECLARED
--     IN A PACKAGE, ARE NOT MADE VISIBLE UNTIL AFTER THE END
--     OF A USE CLAUSE FOR THE PACKAGE.

-- HISTORY:
--     DRE 09/05/02  CREATED TEST

PACKAGE B84007B IS

     PACKAGE PACK1 IS
        TYPE T IS MOD 2;
     END PACK1;

     X1: PACK1.T := 0 OR 1;        -- ERROR: "OR" NOT VISIBLE.
     X2: PACK1.T := 0 XOR 1;       -- ERROR: "XOR" NOT VISIBLE.
     X3: PACK1.T := 0 AND 1;       -- ERROR: "AND" NOT VISIBLE.

     USE PACK1;

     X4: PACK1.T := 0 OR 1;
     X5: PACK1.T := 0 XOR 1;
     X6: PACK1.T := 0 AND 1;

END B84007B;
